import Styles from "@/constants/Styles";
import { apiGetDataHome } from "@/lib/api";
import { useAuthSession } from "@/providers/AuthProvider";
import { router } from "expo-router";
import { useEffect, useState } from "react";
import { View } from "react-native";
import DiscussionItem from "../discussionItem";
import Skeleton from "../skeleton";
import Text from "../Text";

type Props = {
   id: string
   idDivision: string
   desc: string
   title: string
   date: string
   user: string
}

export default function DisccussionHome({ refreshing }: { refreshing: boolean }) {
   const { decryptToken, token } = useAuthSession()
   const [data, setData] = useState<Props[]>([])
   const [loading, setLoading] = useState(true)


   async function handleData(loading: boolean) {
      try {
         setLoading(loading)
         const hasil = await decryptToken(String(token?.current))
         const response = await apiGetDataHome({ cat: "discussion", user: hasil })
         setData(response.data)
      } catch (error) {
         console.error(error)
      } finally {
         setLoading(false)
      }
   }

   useEffect(() => {
      if (refreshing)
         handleData(false)
   }, [refreshing]);

   useEffect(() => {
      handleData(true)
   }, []);

   return (
      <View style={[Styles.mb15]}>
         <Text style={[Styles.textDefaultSemiBold, Styles.mv10]}>Diskusi</Text>
         <View style={[Styles.wrapPaper]}>
            {
               loading ?
                  <>
                     <Skeleton width={100} height={70} borderRadius={10} widthType="percent" />
                     <Skeleton width={100} height={70} borderRadius={10} widthType="percent" />
                  </>
                  :
                  data.length > 0 ?
                     data.map((item, index) => {
                        return (
                           <DiscussionItem key={index} title={item.desc} user={item.user} date={item.date} onPress={() => { router.push(`/division/${item.idDivision}/discussion/${item.id}`) }} />
                        )
                     })
                     : <Text style={[Styles.textDefault, Styles.cGray, { textAlign: 'center' }]}>Tidak ada diskusi</Text>
            }
         </View>
      </View>
   )
}